#ifndef BONDSETTINGSDIALOG_H
#define BONDSETTINGSDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QAbstractButton>
#include "minmaxdelegate.h"

#if defined(JAV_WIDGET)
class CrystalViewWidget;
#else
class JavWindow;
#endif

typedef struct {
                 int   z1, z2;
                 float distmin, distmax;
                 int typeb;
                 int kleg;
               } _BondTable;

typedef struct {
                 float tolmin, tolmax; //bond if dmin+tolmin < d < dmax+tolmax
                 float angle;          //bond if l'angolo < angle
               } _BondSetting;

namespace Ui {
class BondSettingsDialog;
}

class BondSettingsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit BondSettingsDialog(QWidget *parent = nullptr);
    ~BondSettingsDialog();
    int on_bondsetting();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);
    //void onItemChanged(QStandardItem* item);

private:
    Ui::BondSettingsDialog *ui;
    QStandardItemModel *bondModel;
    _BondTable *CurBondTable;
    _BondTable *CurBondTableSav;
    _BondSetting BSettingSav;
    MinMaxDelegate *m_delegate;
#if defined(JAV_WIDGET)
    CrystalViewWidget *jav;
#else
    JavWindow *jav;
#endif

    void get_values_for_BondSetting(_BondTable btable[], _BondSetting &BSetting);
    void reject();
    void set_values_for_Bsetting(_BondSetting BSetting);
};

#endif // BONDSETTINGSDIALOG_H
