#ifndef BONDVALENCEDIALOG_H
#define BONDVALENCEDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include "models.h"
#include "bvpardialog.h"

#if defined(JAV_WIDGET)
class CrystalViewWidget;
#else
class JavWindow;
#endif

namespace Ui {
class BondValenceDialog;
}

class BondValenceDialog : public QDialog
{
    Q_OBJECT

public:
    explicit BondValenceDialog(QWidget *parent = nullptr);
    ~BondValenceDialog();
    int on_bondvs(int whichModel);

private slots:
    void bvsTable_currentRowChanged(const QModelIndex & current, const QModelIndex & previous);
    void on_buttonBox_rejected();
    void on_exportButton_clicked();
    void on_pushButton_clicked();

private:
    Ui::BondValenceDialog *ui;
    Model *md;
    int wm;
    int selectedRow;
    int selectedRowPrevious;
    QStandardItemModel *bvsModel;
    QStandardItemModel *binfoModel;
    BvParDialog *mBvParDialog;
#if defined(JAV_WIDGET)
    CrystalViewWidget *jav;
#else
    JavWindow *jav;
#endif
};

#endif // BONDVALENCEDIALOG_H
