#ifndef CELLPARAMETERSWIDGET_H
#define CELLPARAMETERSWIDGET_H

#include "sg_database.h"
#include <QWidget>

namespace Ui {
class CellParametersWidget;
}

class CellParametersWidget : public QWidget
{
    Q_OBJECT

public:
    explicit CellParametersWidget(QWidget *parent = nullptr);
    ~CellParametersWidget();

    void setCell(const double cellpar[], const QString spg);
    void getCellParameters(double cellp[6]) const;
    void updateCell(const QString &spg);
    void hideRefineCheckBox();
    double cellVolume() const;
    bool anyIsEmpty();
    bool isCellChanged();
    bool isCellRefined();
    void setRefineEnabled(bool enable);

signals:
    void cellParametersModified();

private:
    Ui::CellParametersWidget *ui;
    double cell[6];
    double cellSav[6];
    int cellcode[6];
    double cellVol;
    void setLineEdit();
    void updateVolume();    
};

#endif // CELLPARAMETERSWIDGET_H
