#ifndef DOCDIALOG_H
#define DOCDIALOG_H

#include "dofwidget.h"
#include "checkboxheader.h"

#include <QDialog>

class QStandardItemModel;
class QSortFilterProxyModel;

namespace Ui {
class DocDialog;
}

class DocDialog : public QDialog
{
    Q_OBJECT

public:
    explicit DocDialog(const QVector<AtomInfo> &atoms, QWidget *parent = nullptr);
    ~DocDialog();
    void updateAtoms(QVector<AtomInfo> &atoms);

private slots:
    void headerCheckBoxClicked(bool state, int column);
    void checkBoxClicked(const QModelIndex &index, bool state);

private:
    Ui::DocDialog *ui;
    QStandardItemModel *atomParModel;
    QSortFilterProxyModel *atomParProxyModel;
    CheckBoxHeader *cbHeader;
    CheckBoxHeader *docCbheader;

    void createAtomParModel(const QVector<AtomInfo> &atoms);
    void setAtomParTableView();
    int rowCheckBoxClickedCount(int col) const;

    enum {COL_ATOM, COL_OCC, COL_DOC, COL_BISO, COL_BISOCODE};
};

#endif // DOCDIALOG_H
