#include "expoaboutdialog.h"
#include "ui_expoaboutdialog.h"
#include "qt_utils.h"

#include <QPainter>
#include <QFileInfo>
#include <QDateTime>
#include <QSettings>

ExpoAboutDialog::ExpoAboutDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ExpoAboutDialog)
{
    ui->setupUi(this);
    this->setWindowTitle("About " + qApp->applicationName());

    QPixmap pix(":/pixmaps/pixmaps/aboutexpo.png");
    QPainter painter(&pix);
    QPen pen(Qt::black);
    painter.setPen (pen);

    //Draw Text
    QFont mFont;
    mFont.setPointSize(20);
    mFont.setBold(true);
    painter.setFont(mFont);
    int xpos = 250, ypos = 155, offset = 30, offset1 = 20;
    painter.drawText(QPoint(xpos,ypos),
               QString("%1 Version %2").arg(qApp->applicationName(), qApp->applicationVersion()));
    mFont.setBold(false);
    mFont.setPointSize(11);
    painter.setFont(mFont);
    AppVersionInfo appVersion = getVersionInfo();
    painter.drawText(QPoint(xpos,ypos+=offset), QString("Created on %1").arg(appVersion.data));
    painter.drawText(QPoint(xpos,ypos+=offset1), appVersion.compilersString);
    painter.drawText(QPoint(xpos,ypos+=offset1), appVersion.qtVersionInfo);

    //Add pixmaps
    QPixmap cnrPix(":/pixmaps/pixmaps/logo_CNR_compatto.png");
    QRectF target(270,290,179,114);
    QRect sourceRect = cnrPix.rect();
    painter.drawPixmap(target,cnrPix,sourceRect);

    QPixmap icPix(":/pixmaps/pixmaps/logo_IC.png");
    target = QRectF(440,300,208,66);
    sourceRect = icPix.rect();
    painter.drawPixmap(target,icPix,sourceRect);

    ui->settingsFileLabel->setText(QSettings().fileName());

    ui->aboutLabel->setPixmap(pix);    
    ui->aboutLabel->setFixedSize(pix.width(),pix.height());
}

ExpoAboutDialog::~ExpoAboutDialog()
{
    delete ui;
}
