#ifndef FILTRI_H
#define FILTRI_H

enum filtri { ALL_FILES, CIF_FILE, PDB_FILE, SHELX_FILE, FRA_FILE,
       XYZ_FILE, ZMT_FILE, MOL_FILE, MOL2_FILE, MOP_FILE,
       POV_FILE, GAMESS_OUT, NWCHEM_OUT, ABINIT_OUT, GAMESS_IN, NWCHEM_IN,
       GAUSSIAN_CART_IN, GAUSSIAN_ZMAT_IN, NWCHEM_IN_DFTD, ABINIT_IN,
       CRYSTAL_IN, CRYSTAL_OUT, QE_IN, QE_OUT};

static const QString FilesToImport = {
   "All Readable Files "
   "(*.cif *.mol *.mop *.mol2 *.ml2 *.pdb *.ent *.fhz *.fh *.fra *.frac *.xyz *.ins *.res);;"
   "Crystallographic Information File (*.cif);;"
   "MOL files (*.mol *.sdf *.sd *.mdl);;"
   "MOPAC Input File Format (*.mop);;"
   "Tripos SYBYL Mol2 File (*.mol2 *.ml2);;"
   "Protein Data Bank (*.pdb *.ent);;"
   "Fenske-Hall Z-matrix (*.fhz *.fh);;"
   "Free Form Fractional (*.fra *.frac);;"
   "XYZ Cartesian Format (*.xyz);;"
   "SHELXL file (*.ins *.res);;"
   "GAMESS Output (*.out,*.log);;"
   "NWChem Output (*.out,*.log);;"
   "MOPAC Output File Format (*.out);;"
   "ABINIT Output File Format (*.out);;"
   "CRYSTAL Output File Format (*.out);;"
   "Quantum Espresso Output (*.out)"
};

static const QString FilesToExport = {
   "All Supported Files "
   "(*.cif *.mop *.mol *.sdf *.pdb *.ent *.fhz *.fh *.frac *.xyz *.ins *.res *.pov *.inp *.gamin *.nw *.com *.gau *.gzmat *.in *.d12);;"
   "Crystallographic Information File (*.cif);;"
   "MDL Molfile (*.mol *.sdf);;"
   "MOPAC Cartesian Format (*.mop);;"
   "Protein Data Bank (*.pdb *.ent);;"
   "Fenske-Hall Z-matrix (*.fhz *.fh);;"
   "Free Form Fractional (*.frac);;"
   "XYZ Cartesian Format (*.xyz);;"
   "SHELXL file (*.ins *.res);;"
   "PovRay Format (*.pov);;"
   "GAMESS Input (*.inp *.gamin);;"
   "NWCHEM Input (*.nw);;"
   "GAUSSIAN Cartesian Input (*.com *.gau);;"
   "GAUSSIAN Z-matrix Input (*.gzmat);;"
   "ABINIT Input (*.in);;"
   "CRYSTAL Input (*.d12);;"
   "Quantum Espresso Input (*.in)"
};

static int FILT_IN_READ[] = {ALL_FILES, CIF_FILE, MOL_FILE, MOP_FILE, MOL2_FILE,
                      PDB_FILE, ZMT_FILE, FRA_FILE, XYZ_FILE, SHELX_FILE,
                      GAMESS_OUT, NWCHEM_OUT, NWCHEM_OUT, ABINIT_OUT,
                      CRYSTAL_OUT, QE_OUT};

static int FILT_IN_WRITE[] = {ALL_FILES, CIF_FILE, MOL_FILE, MOP_FILE, PDB_FILE,
                      ZMT_FILE, FRA_FILE, XYZ_FILE, SHELX_FILE, POV_FILE,
                      GAMESS_IN, NWCHEM_IN, GAUSSIAN_CART_IN, GAUSSIAN_ZMAT_IN,
                      ABINIT_IN, CRYSTAL_IN, QE_IN};

#endif
