#ifndef FORMULAEDITOR_H
#define FORMULAEDITOR_H

#include <QLineEdit>

class FormulaEditor : public QLineEdit
{
    Q_OBJECT

public:
    explicit FormulaEditor(QWidget *parent = nullptr);
    void setInfoEnabled(bool enabled, double cellVol = -1);
    void setCellVolume(double value);
    void validateFormula();

    bool isValid() const;
    double volume() const;
    double volumePerAtom() const;
    double density() const;
    double MW() const;    



signals:
    void formulaChanged();

private:    
    bool infoEnabled;    
    double cellVolume;
    bool valid;
    double vol;
    double volPerAtom;
    double dens;
    double mw;
};

#endif // FORMULAEDITOR_H
