#ifndef FOURIERDIALOG_H
#define FOURIERDIALOG_H

#include <QDialog>
#include <QAbstractButton>

typedef struct {
    int fourType;
    int npeaks;
    int weiType;
    int refSelection;
    float refPerc;
    int showFourier;
} FourierConditions;

namespace Ui {
class FourierDialog;
}

class FourierDialog : public QDialog
{
    Q_OBJECT

public:
    explicit FourierDialog(QWidget *parent = nullptr);
    ~FourierDialog();
    void setDialog();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    Ui::FourierDialog *ui;
    FourierConditions fourCond, fourCondSav;
    void setConditions();
    void getConditions();
};

#endif // FOURIERDIALOG_H
