#include "itemdelegate.h"
#include <QComboBox>
#include <QDoubleSpinBox>
#include <QMouseEvent>
#include <QPainter>
#include <QStyleOption>
#include <QApplication>
#include <QDebug>

/*
 * ComboDelegate
 */
ComboDelegate::ComboDelegate(QObject *parent) :
    QItemDelegate(parent)
{
}

void ComboDelegate::setItems(QStringList items)
{
    m_sItemList = items;
}

QWidget *ComboDelegate::createEditor(QWidget *parent,const QStyleOptionViewItem &/*option*/,const QModelIndex &/*index*/) const
{
    QComboBox *editor = new QComboBox(parent);
    editor->addItems(m_sItemList);
    editor->installEventFilter(const_cast<ComboDelegate*>(this));
    return editor;
}

void ComboDelegate::setEditorData(QWidget *editor,const QModelIndex &index) const
{
    QString str =index.model()->data(index).toString();

    QComboBox *box = static_cast<QComboBox*>(editor);
    int i=box->findText(str);
    box->setCurrentIndex(i);
}

void ComboDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
    QComboBox *box = static_cast<QComboBox*>(editor);
    QString str = box->currentText();
    model->setData(index,str);
}

void ComboDelegate::updateEditorGeometry(QWidget *editor,const QStyleOptionViewItem &option, const QModelIndex &/*index*/) const
{
    editor->setGeometry(option.rect);
}

/*
 * SpinBoxDelegate
 */
//SpinBoxDelegate::SpinBoxDelegate(QObject *parent) :
//    QItemDelegate(parent)
//{
//    //Initialize minimum and maximum
//    minValue = 1.00;
//    maxValue = 100.00;
//}

//void SpinBoxDelegate::setRange(double min, double max)
//{
//    minValue = min;
//    maxValue = max;
//}

//QWidget *SpinBoxDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
//{
//    Q_UNUSED(option);
//    Q_UNUSED(index);
//    QDoubleSpinBox *editor =  new QDoubleSpinBox(parent);
//    editor->setMinimum(minValue);
//    editor->setMaximum(maxValue);
//    editor->setDecimals(4);
//    editor->setSingleStep(0.01);
//    return editor;
//}

//void SpinBoxDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
//{
//    double value = index.model()->data(index, Qt::EditRole).toDouble();
//    QDoubleSpinBox *spinBox =  static_cast <QDoubleSpinBox*>(editor);
//    spinBox->setValue(value);
//}

//void SpinBoxDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
//{
//    QDoubleSpinBox *spinBox =  static_cast <QDoubleSpinBox*>(editor);
//    spinBox->interpretText();
//    double value = spinBox->value();
//    model->setData(index, value, Qt::EditRole);
//}

//void SpinBoxDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const
//{
//    Q_UNUSED(index);
//    editor->setGeometry(option.rect);
//}

/*
 * CheckBoxDelegate
 */
//static QRect CheckBoxRect(const QStyleOptionViewItem &viewItemStyleOptions)/*const*/
//{
//    QStyleOptionButton checkBoxStyleOption;
//    //Region occupied by QCheckBox
//    QRect checkBoxRect = QApplication::style()->subElementRect( QStyle::SE_CheckBoxIndicator, &checkBoxStyleOption);
//    //Coordinates of QCheckBox
//    QPoint checkBoxPoint(viewItemStyleOptions.rect.x() + viewItemStyleOptions.rect.width() / 2 - checkBoxRect.width() / 2,
//                         viewItemStyleOptions.rect.y() + viewItemStyleOptions.rect.height() / 2 - checkBoxRect.height() / 2);
//    //Return the geometry of QCheckBox
//    return QRect(checkBoxPoint, checkBoxRect.size());
//}

//CheckBoxDelegate::CheckBoxDelegate(QObject *parent):
//    QStyledItemDelegate(parent)
//{

//}

//void CheckBoxDelegate::setColumn(int col)
//{
//    column = col;
//}

//// Draw checkbox
//void CheckBoxDelegate::paint(QPainter* painter, const QStyleOptionViewItem& option,const QModelIndex& index)const
//{
//    bool checked = index.model()->data(index, Qt::DisplayRole).toBool();

//    if(index.column() == column){
//        QStyleOptionButton checkBoxStyleOption;
//        checkBoxStyleOption.state |= QStyle::State_Enabled;
//        checkBoxStyleOption.state |= checked? QStyle::State_On : QStyle::State_Off;
//        checkBoxStyleOption.rect = CheckBoxRect(option);

//        QApplication::style()->drawControl(QStyle::CE_CheckBox,&checkBoxStyleOption,painter);
//    }else{
//        QStyledItemDelegate::paint(painter, option, index);
//    }
//}

//// Update data in response to mouse events
//bool CheckBoxDelegate::editorEvent(QEvent *event,
//                                QAbstractItemModel *model,
//                                const QStyleOptionViewItem &option,
//                                const QModelIndex &index) {
//    if(index.column() == column){
//    if((event->type() == QEvent::MouseButtonRelease) ||
//            (event->type() == QEvent::MouseButtonDblClick)){
//        QMouseEvent *mouseEvent = static_cast<QMouseEvent*>(event);
//        if(mouseEvent->button() != Qt::LeftButton ||
//                !CheckBoxRect(option).contains(mouseEvent->pos())){
//            return true;
//        }
//        if(event->type() == QEvent::MouseButtonDblClick){
//            return true;
//        }
//    }else if(event->type() == QEvent::KeyPress){
//        if(static_cast<QKeyEvent*>(event)->key() != Qt::Key_Space &&
//                static_cast<QKeyEvent*>(event)->key() != Qt::Key_Select){
//            return false;
//        }
//    }else{
//        return false;
//    }

//    bool checked = index.model()->data(index, Qt::DisplayRole).toBool();
//    int data = checked ? 0 : 1;     //互逆
//    return model->setData(index, data, Qt::EditRole);
//    }else{
//        return QStyledItemDelegate::editorEvent(event, model, option, index);
//    }
//}
