#ifndef ITEMDELEGATE_H
#define ITEMDELEGATE_H

#include <QItemDelegate>
#include <QStyledItemDelegate>

/*
 * ReadOnly
 */
class ReadOnlyDelegate : public QItemDelegate
{
    Q_OBJECT
public:
    ReadOnlyDelegate(QObject *parent = nullptr): QItemDelegate(parent) {}

    void setItems(QStringList items);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex	&index) const
    {
        Q_UNUSED(parent);
        Q_UNUSED(option);
        Q_UNUSED(index);
        return NULL;
    }
};

/*
 * ComboBox
 */
class ComboDelegate : public QItemDelegate
{
    Q_OBJECT
public:
    ComboDelegate(QObject *parent = 0);

    void setItems(QStringList items);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex	&index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const  QModelIndex &index) const;

private:
    QStringList m_sItemList;
};

/*
 * DoubleSpinBox
 */
//class SpinBoxDelegate : public QItemDelegate
//{
//    Q_OBJECT
//public:
//    SpinBoxDelegate(QObject *parent = 0);

//    void setRange(double min, double max);

//    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex	&index) const;
//    void setEditorData(QWidget *editor, const QModelIndex &index) const;
//    void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;
//    void updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const  QModelIndex &index) const;

//private:
//    double minValue;
//    double maxValue;
//};

/*
 * CheckBox
 */
//class CheckBoxDelegate : public QStyledItemDelegate
//{
//    Q_OBJECT
//public:
//    CheckBoxDelegate(QObject *parent = 0);

//    void setColumn(int col);

//protected:
//    void paint(QPainter* painter,const QStyleOptionViewItem& option,const QModelIndex& index) const;
//    bool editorEvent(QEvent *event,QAbstractItemModel *model,const QStyleOptionViewItem &option,const QModelIndex &index);

//private:
//    int column;
//};

#endif // ITEMDELEGATE_H
