#include "modelloader.h"
#include "ui_modelloader.h"
#include "filtri.h"
#include "javkeysettings.h"

#include <QSettings>
#include <QFileDialog>

ModelLoader::ModelLoader(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::ModelLoader)
{
    ui->setupUi(this);
}

bool ModelLoader::isEmpty()
{
    return ui->modelLineEdit->text().trimmed().isEmpty();
}

QStringList ModelLoader::modelList()
{
    if (isEmpty()) return QStringList();
    return ui->modelLineEdit->text().split(u';');
}

ModelLoader::~ModelLoader()
{
    delete ui;
}

void ModelLoader::on_modelPushButton_clicked()
{
    QSettings settings;
    QString selectedFilter = settings.value(IMPORT_STRUCTURE_FILTER_KEY).toString();;
    QString fileName = QFileDialog::getOpenFileName(this,
        tr("Select File to Read from"), settings.value(DEFAULT_DIR_KEY).toString(),
        FilesToImport, &selectedFilter);
    settings.setValue(IMPORT_STRUCTURE_FILTER_KEY,selectedFilter);
    if (!fileName.isEmpty()) {
        settings.setValue(DEFAULT_DIR_KEY,QFileInfo(fileName).absolutePath());

        if (isEmpty()) {
            ui->modelLineEdit->setText(fileName);
        } else {
            QString line = ui->modelLineEdit->text() + "; " + fileName;
            ui->modelLineEdit->setText(line);
        }
        emit modelChanged();
    }
}

void ModelLoader::on_modelLineEdit_textChanged(const QString &arg1)
{
    Q_UNUSED(arg1);
    emit modelChanged();
}
