#include "myproxymodel.h"

MyProxyModel::MyProxyModel(QObject *parent)
    : QSortFilterProxyModel(parent)
{
}

bool MyProxyModel::lessThan(const QModelIndex &left,
                                      const QModelIndex &right) const
{
    QVariant leftData = sourceModel()->data(left);
    QVariant rightData = sourceModel()->data(right);
    QModelIndex leftIndex, rightIndex;
    int colN = left.column();
    if(isIntColumn(colN))
        return(leftData.toInt() < rightData.toInt());
    else if(isFloatColumn(colN))
        return(leftData.toFloat() < rightData.toFloat());
    else if(isDoubleColumn(colN))
        return(leftData.toDouble() < rightData.toDouble());
    else if(isAlphaColumn(colN))
        return(QString::localeAwareCompare(leftData.toString(), rightData.toString()) < 0);
    else if(isSpecialColumn(colN))
    {
        leftIndex = sourceModel()->index(left.row(),columnForSort,QModelIndex());
        leftData = sourceModel()->data(leftIndex);
        rightIndex = sourceModel()->index(right.row(),columnForSort,QModelIndex());
        rightData = sourceModel()->data(rightIndex);
        return(leftData.toInt() < rightData.toInt());
    }
    else
        return false;
}

