#ifndef POWDERPATTERN_H
#define POWDERPATTERN_H

#include <QDialog>
#include "grafico.h"
#include "libcomune.h"
#include "powderpatternsettings.h"

namespace Ui {
class PowderPattern;
}

using namespace GraphicSpace;

typedef struct {
                int h, k, l;
               }_HKL;

class PowderPattern : public QDialog
{
    Q_OBJECT

public:
    explicit PowderPattern(QWidget *parent = 0);
    ~PowderPattern();
    void FillPowderPatternDlg(int whichModel, QString filename);
    void DoPowderPattern(float x[], float y[], int num,
                           reflection_type *refjav, int num1);
    int Myminloc(float *vect, float val);
    QString StatusMessage(QPointF p);
    static QString MessForSB(QPointF p);

private:
    Ui::PowderPattern *ui;
    xpd_option_type m_xpd;
    Grafico *m_Scene;
    int m_Kmodel;
    QString m_FileName;
    float *tthd;
    _HKL  *hkl;
    int nref;
    PowderPatternSettings *mPdPsett;

protected:
    void resizeEvent(QResizeEvent *) override;

private slots:
    void on_exportButton_clicked();
    void on_settingsButton_clicked();
    void on_resetButton_clicked();
    void on_closeButton_clicked();
};

#endif // POWDERPATTERN_H
