#ifndef PROCESSDIALOG_H
#define PROCESSDIALOG_H

#include <QDialog>
#include <QProcess>
#include <QAbstractButton>

namespace Ui {
class ProcessDialog;
}

class ProcessDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ProcessDialog(QWidget *parent = nullptr);
    ~ProcessDialog();

    void setProgram(const QString &program);
    void setArguments(const QStringList &arguments);
    void start();
    void waitAndProcessEvents();
    QProcess::ProcessState state() const;
    QProcess *process() const;
    void setProgramName(const QString &newProgramName);

signals:
    void processDialogFinished();

public slots:
    void terminateProcess();

private slots:
    void displayOutput();
    void processFinished();
    void onButtonBoxClicked(QAbstractButton *button);
    void processError(QProcess::ProcessError error);

private:
    Ui::ProcessDialog *ui;
    QProcess *mProcess;
    QString programName;
    bool programTerminated;
};

#endif // PROCESSDIALOG_H
