#ifndef SHADERPROGRAM_H
#define SHADERPROGRAM_H

#include <QString>
#include <QMatrix4x4>

class QOpenGLShaderProgram;

class ShaderProgram
{
public:
    ShaderProgram();
    ShaderProgram(const QString & vertexShaderFilePath, const QString & fragmentShaderFilePath);

    // Use/activate shader
    void use();

    // Destroys OpenGL resources, OpenGL context must be made current before this function is callded!
    void destroy();

    // Utility uniform functions
    void setBool(const QString &name, bool value) const;
    void setInt(const QString &name, int value) const;
    void setFloat(const QString &name, float value) const;
    void setMat4(const QString &name, const QMatrix4x4 &mat4) const;

    QOpenGLShaderProgram *program() const;

private:
    QOpenGLShaderProgram *m_program;

};

#endif // SHADERPROGRAM_H
