! ----------------------------------------------------------------------

      integer function get_hill_formula(cform,hform) result(ier)
      use elements
      implicit none
      character(len=*), intent(in)  :: cform
      character(len=*), intent(out) :: hform
      character(len=:), allocatable :: hhform
!
      call read_chemformula(cform,strfor=hhform,ord=.true.,fform=0,
     *                      hide1=.true.,ier=ier)
      if (ier == 0) hform = trim(hhform)//char(0)
!
      end function get_hill_formula

! ----------------------------------------------------------------------

      subroutine MsgWin2(MsgW,nType,iExitC,itempo)
      !USE Molcom
!
      character*(*), intent(in) :: MsgW
      integer, intent(in)       :: nType
      integer, intent(out)      :: iExitC
      integer, intent(in)       :: itempo
! ---
!     
! --- 
      !l2 = Lung(MsgW)
      !write(0,'(a)') 'FIX MsgWinC2'
      !call MsgWinC2(MsgW(1:l2)//char(0), nType, iEnterExitC, itempo)
      call MsgWinErr('Error',MsgW,nType,iExitC)
!     
      end subroutine MsgWin2
! ----------------------------------------------------------------------
!qt      subroutine MsgWinErr(String,mesg,nType,iExitC)
!qt      USE General
!qt!corr      USE Molcom, only: jscreen
!qt      USE strutil, only: Lung,write_formatted_message
!qt      implicit none
!qt!
!qt!corr      interface
!qt!corr      subroutine MsgWinErrNew(String,mesg,nType,iExitC,winval)
!qt!corr      character*(*), intent(in)     :: String, mesg
!qt!corr      integer, intent(in)           :: nType
!qt!corr      integer, intent(out)          :: iExitC
!qt!corr      integer, intent(in)           :: winval
!qt!corr      end subroutine MsgWinErrNew
!qt!corr      end interface
!qt!
!qt      character*(*), intent(in) :: String, mesg
!qt      integer, intent(in)       :: nType
!qt      integer, intent(out)      :: iExitC
!qt!
!qt      call MsgWinErrNew(String,mesg,nType,iExitC)
!qt!
!qt      end subroutine MsgWinErr
! ----------------------------------------------------------------------
      subroutine MsgWinErr(String,mesg,nType,iExitC)
      USE General, only: Msg, Inte, lo, SEVERE_ERR_WINDOW, 
     *ifAutomatic, QUEST_WINDOW_NO_YES
      USE Molcom, only: kscreen
      USE prognames, only: package_alt_name
      USE strutil, only: Lung,write_formatted_message,f_to_c
      implicit none
      interface
         subroutine MsgWinErrC(inte, msg, tipo, exitC) 
     *   bind(C,name="MsgWinErrC1")
         use iso_c_binding
         character(c_char), intent(in)     :: inte(*), msg(*)
         integer(c_int), intent(in), value :: tipo
         integer(c_int), intent(out)       :: exitC
         end subroutine MsgWinErrC
      end interface 
!
      character*(*), intent(in) :: String, mesg
      integer, intent(in)       :: nType
      integer, intent(out)      :: iExitC
      integer                   :: ki,kf
      integer                   :: nchar,l2
!
      nchar = 70
      l2 = min0(Lung(mesg), 240)
      if (l2.gt.0) then
          Msg = mesg(1:l2)                !mr 290702
      else
          Msg = ' '
      endif
      l2 = min0(Lung(String), 80)
      if (l2.gt.0) then
          Inte = String(1:l2)             !mr 300403
      else
          Inte = ' '
      endif
!
      ki = 1
      kf = Lung(Msg)
      if (nType.eq.SEVERE_ERR_WINDOW) then
          Msg(kf+1:) = char(10)//package_alt_name//
     *    ' will be terminated!!!'
          kf = Lung(Msg)
      endif

      call write_formatted_message(lo,Inte,Msg,74)
      
! ---
      if (kscreen > 0 .and. ifAutomatic == 0) then
          call MsgWinErrC(f_to_c(String), f_to_c(mesg),
     *                nType, iExitC)
      else
          if (nType == QUEST_WINDOW_NO_YES) then
              iExitC = 0
          else
              iExitC = 1
          endif
      endif
!
      return
      end subroutine MsgWinErr
!qt! ----------------------------------------------------------------------
!qt      subroutine ControllaDir(dir,ierw)
!qt!
!qt      character*(*) dir
!qt!
!qt      k = Lung(dir)
!qt      dir(k+1:k+1) = char(0)
!qt      call c_controlladir(dir,ierw)
!qt      if (ierw == 0) then
!qt          ierw = -1
!qt      else
!qt          ierw = 0
!qt      endif
!qt!
!qt      return
!qt      end
!qt! ----------------------------------------------------------------------
!qt      subroutine zflush
!qt!
!qt      call cflush()
!qt!
!qt      return
!qt      end
!qt! ----------------------------------------------------------------------
      subroutine punto_e_basta(ix, iy)
!
      call cpunto_e_basta(ix,iy)
!
      return
      end
! ----------------------------------------------------------------------
!qt      subroutine getRGB(indice_colore, rgb)
!qt      USE General
!qt      USE Molcom
!qt!
!qt      dimension rgb(3)
!qt!
!qt      call c_getrgb(indice_colore, rgb)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
      subroutine UpdateMenu()
      USE General
      USE Molcom
!
      call c_update_menu_recprj()
!
      return
      end
!---------------------------------------------------------------------
      subroutine manage_console(iAction)
!
      call c_manage_console(iAction)
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine RunToolBar(iAction,string)
!qt!
!qt      return
!qt      end
! ----------------------------------------------------------------------
      subroutine Chiocciola(Megastringa, Buffer,ifLcase)
!
      character*(*) MegaStringa, Buffer
!
      ik = index(MegaStringa,'@')
      if (ik.le.1) then
          Buffer = ' '
      else
          Buffer = Megastringa(1:ik-1)
      endif
      Megastringa(1:ik) = ' '
      call shift(Megastringa,lenp)
      call shift(Buffer,lenp)
      if (ifLcase.eq.1) then
          call lcase(Buffer)
      endif
!
      return
      end
! ---------------------------------------------------------------------
!corr      subroutine savebinfile()
!corr      USE General
!corr!
!corr      character *256 filename
!corr!
!corr      k = index(fname(1),'.bin')
!corr      filename = fname(1)(1:k) // 'sav'
!corr      call savelist(ier,filename)
!corr!
!corr      if (ier.eq.0) then
!corr          write(Msg,10) filename(1:Lung(filename))
!corr          call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
!corr      endif
!corr   10 format('The project binary file has been saved in ',a,'.')
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!corr      subroutine restorebinfile
!corr      USE General
!corr      USE Molcom
!corr!
!corr      common /unitbak/ jdirbak
!corr      common /xfili/ lfirst,nwblo,lindex(240)
!corr      common /yfili/ lfirsty,nwbloy,lindey(240)
!corr      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
!corr!
!corr      character*256 file1, file2, nome
!corr      character*256 file1a, file2a, nomea
!corr      character *80 filebak
!corr      character *80 Buffer
!corr      integer system
!corr
!corr!
!corr      k = index(fname(1),'.bin')
!corr      filebak = fname(1)(1:k) // 'sav'
!corr      nome  = fname(1)(1:k-1)
!corr      file1 = fname(1)(1:k) // 'bin'
!corr      file2 = fname(1)(1:k) // 'out'
!corr      jdirbak = jfile
!corr      ifFileOK = 1
!corr!
!corr!-- does restored file exist ?
!corr!
!corr      itipe = 2
!corr      kop = kopen(jfile,filebak,nlen,itipe,ierr)
!corr      if (kop.lt.0) then
!corr          ifFileOK = 0
!corr      else
!corr          call star9y
!corr          call xdwny(lfirsty,lindey,10)
!corr!
!corr!-- is it a valid sir-binary file ?
!corr!
!corr          if(lindey(8).eq.ifile) then
!corr              ifFileOK = 1
!corr          else
!corr              ifFileOK = 0
!corr          endif
!corr          close(jfile)
!corr          icfle=-1
!corr      endif
!corr
!corr!-- controllare che il file .sav esista
!corr!-- e sia un file binario valido
!corr!
!corr      if (ifFileOK.eq.1) then
!corr          iAction = 2
!corr          call chiudi_bin(iAction)
!corr          call cCopyFile(filebak, fname(1))
!corr!mr          if(ifW95.eq.0) then
!corr!mr              Buffer = 'cp ' // filebak(1:Lung(filebak)) // ' '
!corr!mr     *                       // fname(1)(1:Lung(fname(1))) // char(0)
!corr!mr          else
!corr!mr              Buffer = 'copy ' // filebak(1:Lung(filebak)) // ' '
!corr!mr     *                       // fname(1)(1:Lung(fname(1))) // char(0)
!corr!mr          endif
!corr!mr          ier = system(Buffer)
!corr
!corr          write(Msg,10) filebak(1:k+3)
!corr          call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
!corr!
!corr          call GetBinV2(nome,file1,file2)
!corr      else
!corr          Msg = 'Impossible to restore '
!corr     *         // filebak(1:Lung(filebak)) // ' !!!'
!corr          call MsgWinErr('Open file error', Msg, WARN_WINDOW, nExitC)
!corr      endif
!corr!
!corr   10 format('The project binary file has been restored from ',a,'.')
!corr!
!corr      return
!corr      end
!old-function! ----------------------------------------------------------------------
!old-function      subroutine importa_file(input_par, iAction)
!old-function      USE General
!old-function      USE ilmviewmod
!old-function      USE fileutil
!old-function!
!old-function!     input_par%str1 = nome del frammento o file da importare
!old-function!     input_par%str2 = directory in cui si trova il file
!old-function!
!old-function      implicit none
!old-function      type (multistringa)  ::input_par
!old-function      integer iAction
!old-function      integer :: n1,n2,ier
!old-function!
!old-function      call ilmview_open(input_par%str1)
!old-function      n1 = input_par%n1
!old-function      n2 = input_par%n2
!old-function      call jav_import_structure
!old-function     *  (input_par%str2(1:n2)//input_par%str1(1:n1)//char(0),iAction,1,
!old-function     *   ier)
!old-function      if (len_trim(structurename) == 0)   
!old-function     * structurename = file_rem_ext(file_get_name(input_par%str1(1:n1)))
!old-function!
!old-function      return
!old-function      end
! ----------------------------------------------------------------------
!old-function      subroutine importa_file(filename, ftype)
!old-function      USE General
!old-function      USE ilmviewmod
!old-function      USE fileutil
!old-function!
!old-function      implicit none
!old-function      character(len=*), intent(in)  :: filename ! full filename including folder name
!old-function      integer, intent(in)           :: ftype  
!old-function      integer                       :: n1,n2,ier
!old-function      character(len=:), allocatable :: basename
!old-function!
!old-function      basename = file_rem_ext(file_get_name(filename))
!old-function      call ilmview_open(basename)
!old-function      call jav_import_structure(filename,ftype,1,ier)
!old-function      if (len_trim(structurename) == 0)   
!old-function     * structurename = basename
!old-function!
!old-function      end subroutine importa_file
!-----------------------------------------------------------------------
!corr
!corr      subroutine importa_file(filename, length, ftype) 
!corr     *bind(C,name="importa_file")
!corr      USE iso_c_binding, only: c_char, c_int
!corr      USE General, only: structurename
!corr      USE ilmviewmod
!corr      USE fileutil
!corr      USE strutil
!corr      USE enable_amb
!corr!
!corr      implicit none
!corr      character(kind=c_char), intent(in) :: filename(*) ! full filename including folder name
!corr      integer(c_int), intent(in), value  :: length
!corr      integer(c_int), intent(in), value  :: ftype
!corr      integer                            :: n1,n2,ier
!corr      character(len=:), allocatable      :: basename
!corr      character(len=:), allocatable      :: filnam
!corr!
!corr      filnam = toFortranString(filename,length)
!corr      basename = file_rem_ext(file_get_name(filnam))
!corr      call ilmview_open(basename)
!corr      call jav_import_structure(filnam,ftype,1,ier)
!corr      !call abilita_tasti("structure")
!corr      call abilita_tasti2()
!corr      if (len_trim(structurename) == 0)
!corr     * structurename = basename
!corr!
!corr      end subroutine importa_file
!corr
!-----------------------------------------------------------------------
!corr      subroutine esportanew(iCod, filnam)
!corr      USE Counts
!corr      USE Conteggi
!corr      USE reflection_type_util
!corr      USE proginterface
!corr      USE gen_frm
!corr      USE variables, only: dataset,cryst
!corr      USE General, only: is_extraction
!corr!
!corr      implicit none
!corr      integer                                          :: iCod
!corr      character(len=256)                               :: filename
!corr      character(len=256)                               :: filnam
!corr      integer                                          :: Lung
!corr      type(reflection_type), dimension(:), allocatable :: reflb
!corr!
!corr      filename = filnam(1:Lung(filnam))
!corr      select case (iCod)
!corr        case(16)       ! Powder Pattern
!corr          if (npunti > 0) then
!corr              if (allocated(dataset(1)%yc)) then
!corr                  call export_profile(filename,dataset(1)%x0,
!corr     *         dataset(1)%y,dataset(1)%yc+dataset(1)%yb,dataset(1)%yb,
!corr     *       '#      2theta    yoss     ycalc    yback    ydiff')
!corr              else
!corr                  call export_profile(filename,theta_int(:,7),
!corr     *            theta_int(:,2),string='#      2theta    yoss')
!corr              endif
!corr          endif
!corr
!corr         case (17)     ! Reflection File
!corr          if (cryst(1)%numref() > 0) then
!corr              call copy_ref(reflb,cryst(1)%ref)
!corr              if (.not.is_extraction) reflb%fo = 0.0
!corr              call write_reflections(fname=filename,refl=cryst(1)%ref,
!corr     *        code=2,title='#hkl,F(obs)^2,sigma in SHELX format') ! hkl,Fo-squared
!corr          else
!corr              call MsgWinErr('ERROR','Reflections are not available!',ERR_WINDOW,nExitCode)
!corr          endif
!corr      end select
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
      subroutine save_as(filnam, dirnam)
      USE Molcom
      USE General
      USE PhaseModule
!
!     filnam = nome del file da scrivere
!     dirnam = directory del file da scrivere
!
      character*(*) filnam
      character*(*) dirnam
      character*80 line, filename
!
      Msg = dirnam(1:Lung(dirnam)) // filnam(1:Lung(filnam))
      nlenB = 80
      istat = 0
      iform = 1
      jop=jopen(99,Msg,istat,iform,ierr)
!
      filename = 'tmp.tmp'
      nlenB = 80
      istat = 0
      iform = 1
      jop=jopen(iscra,filename,istat,iform,ierr)
      iEOF = 0
      do while (iEOF.eq.0)
         read(iscra,'(a)',end=100) line
      enddo
!
  100 close(iscra, status='delete')
      close(99)
!
      return
      end
! ----------------------------------------------------------------------
!corr      subroutine init_becca_punti (iCod)
!corr      USE Molcom
!corr      integer*4 iCod 
!corr!
!corr      nptr = 0
!corr      iQualeBecca = iCod
!corr!
!corr      return
!corr      end
!corr
! ----------------------------------------------------------------------
!corr      subroutine becca_punti (ix,iy, ier)
!corr      USE view, only : individua_patt
!corr      USE Conteggi, only:npunti
!corr!
!corr      integer :: ix,iy
!corr      integer :: ier
!corr      character *120 TmpLab
!corr!
!corr      ier = 0
!corr!
!corr      if (npunti > 0) then
!corr          ier = Individua_patt(ix,iy)
!corr      endif
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!corr      subroutine GetBinV2(nome,file1,file2)
!corr      USE General
!corr      character*(*) nome, file1, file2
!corr      character*80  file
!
!corr      fname(1) = file1
!corr      fname(15) = file2
!corr      k = Lung(nome)
!corr      do i=2,14
!corr         file=nome(1:k)//ext(i)
!corr         call xcmprp(file,lfile)
!corr         fname(i)=file(1:lfile)
!corr      enddo
!
!corr      iTipo = 2
!corr      call updSWRC(iTipo,file1,file2)
!corr      call updRecentProjects()                      !mr
!corr      call LoadFromBin(file1,file2,ier)
!
!corr      return
!corr      end
! ----------------------------------------------------------------------

      subroutine exitsir2002() bind(C,name="exitsir2002")
      USE Atomi, only: nats
      USE General, only: ListaOK
      USE PatternRef, only: kexitrun
      USE Molcom, only: ifBrekke
      USE enable_amb, only: STOP_EVENT
      implicit none
      integer :: interp
!
      kexitrun = 1
      ifBrekke = STOP_EVENT
      if (ListaOK(15) == 1 .and. nats /= 0) then
          interp = 1
          call frm15d(interp)
      endif
!
      return
      end

! ----------------------------------------------------------------------
!qt      subroutine kridisegna(newkscrx,newkscry,ier)
!qt      USE VIEW
!qt      USE GREXPOMOD
!qt      USE Molcom
!qt      USE PatternRef
!qt      USE Conteggi
!qt      implicit none
!qt      integer :: newkscrx, newkscry
!qt      integer :: ier
!qt!
!qt      kscrx = newkscrx
!qt      kscry = newkscry
!qt      if (npunti > 0 .and. allocated(theta_int) 
!qt     *  .and. pinioss_sav > 0 .and. pfinoss_sav > 0) then
!qt         ier = 0
!qt         call gr_init(iselview,kscrx,kscry)
!qt         call vedinew(iAct_sav,pinioss_sav,pfinoss_sav,
!qt     *       pinicalc_sav,pfincalc_sav,lsetstyle=.false.)
!qt      else
!qt         ier = 1
!qt      endif
!qt!
!qt      return
!qt      end
! ----------------------------------------------------------------------
      subroutine ridisegna()
      USE VIEW
      USE conteggi
      implicit none
!
      if (npunti > 0 .and. allocated(theta_int)) then
          call vedinew()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine putlab95(filein, fileout, ierr)
      USE General
      USE strutil
      USE fileutil
      USE expo_main
!
      implicit none
      !character*256 :: filein, fileout
      character(len=*) :: filein,fileout
      integer       :: ierr
      character*256 file1, file2
      character*80 Titolo
!corr      integer :: n1,n2,n3,n4
      integer :: i,k,itype,iform,nkscrx,nkscry
      integer :: jop,jopen
      integer :: ier,ier2,iTipo
!
      file1 = remc0(filein)
      file2 = remc0(fileout)
      ierr = 0
      call chiudi_bin(2)
!
      StructureName = file_rem_ext(file_get_name(file1))
      k = Lung(StructureName)
      do i=1,size(fname)
         if (i /= INP_FILE .and. i /= OUT_FILE) then
             fname(i) = s_blank_delete(trim(StructureName)//ext(i))
         endif
      enddo
      fname(INP_FILE) = file1
      fname(OUT_FILE) = file2
      StructureName = file_rem_ext(file_get_name(file1))
      itype = 0
      iform = 1
      close(lo)
      jop = jopen(lo,file2,itype,iform,ier2)
!
      call CheckWindowCommand(file1,nkscrx,nkscry,
     *                        Titolo,ier)
      iTipo = 1
!qt      call updSWRC(iTipo,file1,file2)
      call CheckStructCommand(file1,ier)            !mr 020204
!
!qt      call updRecentProjects()
!qt      call SetWindowTitle(Titolo)
!
      call mainloop(.false.,file1,ierr,param_options_type())
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine finish_disegnarettangolo(ix0,iy0,iw,ih)
!qt      USE VIEW
!qt      USE Conteggi, only:npunti
!qt      implicit none
!qt!
!qt      integer               :: ix0,iy0,iw,ih 
!qt      integer, dimension(4) :: ixp,iyp
!qt!
!qt      !write(0,*)'IW=',ix0,iy0,iw,ih
!qt      !if (iw == 0) return
!qt      if (ix0 < 0) return
!qt!
!qt      ixp(1) = ix0
!qt      iyp(1) = iy0
!qt      ixp(2) = ix0 + iw - 1
!qt      iyp(2) = iy0
!qt      ixp(3) = ix0 + iw - 1
!qt      iyp(3) = iy0 + ih - 1
!qt      ixp(4) = ix0
!qt      iyp(4) = iy0 + ih - 1
!qt!
!qt      if (npunti > 0) then
!qt          call zoomnew1(min(ixp(1),ixp(2)),min(iyp(1),iyp(3)),abs(iw))
!qt      endif
!qt!
!qt      return
!qt      end
! -----------------------------------------------------------------
!corr      subroutine prefourier(natsC,nadd)
!corr      USE General, only: celem, spacegr, neutro
!corr      USE elements
!corr      USE variables, only: atm
!corr      USE atom_type_util
!corr!
!corr      implicit none
!corr      integer*4 natsC 
!corr      integer*4 nadd 
!corr      real :: anat0, anat1
!corr!
!corr      natsC = numatoms(atm)
!corr!
!corr!-- computes number of peaks to add
!corr!
!corr      anat1 = natom_cell(atm,spacegr%nsymop,neutro==0)
!corr      anat0 = nasym_unit(celem,spacegr%nsymop,neutro==0)
!corr      nadd = nint(( anat0 - anat1 ) / spacegr%nsymop)
!corr      if (nadd < 5) then
!corr          nadd = 5
!corr      endif
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
      BLOCK DATA DEPEND
      include 'sircom.fi'
c
      character *80 MessH,Messages(200)
      common /scmess/MessH,Messages
      data nlen/2048/
!corr      data kff/1/
c     Environment
c     kprog =  1     SIR97      ( DOS )
c     kprog =  2     SIRPOW.97  ( DOS )
c     kprog =  3     MOLPLO     ( DOS )
c     kprog =  4     EXTRA      ( DOS )
c     kprog =  5     RIETVELD   ( DOS )
c     kprog = 11     SIR97      ( NON DOS )
c     kprog = 12     SIRPOW.97  ( NON DOS )
c     kprog = 13     MOLPLO     ( NON DOS )
c     kprog = 14     EXTRA      ( NON DOS )
c     kprog = 15     RIETVELD   ( NON DOS )
      data MessH/' '/
!corr      data Messages /200*' '/
c
      end
c ----------------------------------------------------------------------
      subroutine polynomial(iAction,icoef,ival)
      USE view
      common /backp2/ npol(10)
      integer*4 iAction ![REFERENCE]

      jjj=ival+1
      if (iAction==1) then
          icoef = npol(jjj)
      else
          npol(jjj) = icoef
          icontrollo = 1
          call CalcoBacExt(icontrollo)
          call vedinew()
      endif

      return
      end
c ----------------------------------------------------------------------
      subroutine salva_background(iAction,n_intervals)
      USE PatternRef
      common /backp2/ npol(10)
      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
     *,nref1(10),nref2(10),ymx(10),nnt
     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
     *,nref11(10),nref22(10),sscl(10),scala(10)
      common /picbkg/ backp(10000,2),ntyp(10000),bkk(11,10),tmm(10)
     *,nback,ifcamb(10),noback
      integer*4 iAction ![REFERENCE]
      integer*4 n_intervals ![REFERENCE]
!
      common /picbkgsav/nntl,backp2(10000,2),bkkb(11,10),nback2,
     *npolb(10),itipbaI,nactbaI,back_sav(36),ntypb(10000),thminbkgb
!
!     iAction = 1 --> salva background prima delle modifiche
!     iAction = 2 --> ripristina il background salvato se premo CANCEL
!
      n_intervals=nnt - 2
      if (iAction==1) then
         do 1 i=1, nback
            backp2(i, 1) = backp(i,1)
            backp2(i, 2) = backp(i,2)
            ntypb(i)=ntyp(i)
 1       continue
         nback2 = nback
         nntl = nnt
         do i=1,11
            do j=1,10
               bkkb(i, j) = bkk(i, j)
            enddo
         enddo
         do 5 i=1, nnt
            npolb(i) = npol(i)
    5    continue
      else
         nback = nback2
         do 11 i=1, nback
            backp(i,1) = backp2(i, 1)
            backp(i,2) = backp2(i, 2)
            ntyp(i)=ntypb(i)
 11      continue
         nnt = nntl
         do i=1,11
            do j=1,10
               bkk(i, j) = bkkb(i, j)
            enddo
         enddo
         do 15 i=1, nnt
            npol(i) = npolb(i)
   15    continue
         icontrollo = 0
         call CalcoBacExt(icontrollo)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine disegna_interval(ival,kdraw)
      USE VIEW
      USE CommonExpo, only : ncoun1,ncoun2
      USE Conteggi, only: npunti
      USE PatternRef
!
      integer*4 ival  ![REFERENCE]
      integer*4 kdraw ![REFERENCE]
!
      if (kdraw == 2) then
          if (ival >=0) jjj = ival + 1
          if (jjj > 10) then
              xzleft=1
              xzright=npunti
          else
              xzleft=ncoun1(jjj)
              xzright=ncoun2(jjj)
          endif
          call vedinew()
          return
      else if (kdraw == 3) then
          call vedinew()
      endif
      return
      end
! ----------------------------------------------------------------------
!qt      subroutine show_all_pattern()
!qt      USE VIEW
!qt      USE GREXPOMOD
!qt      USE CommonExpo, only : ncoun1,ncoun2
!qt      USE Conteggi, only: npunti
!qt      USE PatternRef
!qt      implicit none
!qt
!qt      kzoomn = .FALSE.;
!qt!corr      if (jjj > 10 .or. jjj <= 0)then
!qt!corr          xzleft=1; xzright=npunti
!qt!corr      else
!qt!corr          xzleft=ncoun1(jjj); xzright=ncoun2(jjj)
!qt!corr      endif
!qt      if (iAct_sav == 4 .and.(jjj > 0 .and. jjj <= 10)) then
!qt          xzleft=ncoun1(jjj); xzright=ncoun2(jjj)
!qt      else
!qt          xzleft=1; xzright=npunti
!qt      endif
!qt      call vedinew()
!qt      return
!qt      end
! ----------------------------------------------------------------------
! ----------------------------------------------------------------------
!corr      subroutine recycle()
!corr      USE General
!corr      USE Molcom
!corr      USE PatternRef
!corr      USE atomi, only:nats
!corr      USE PhaseModule, only: setmin, erm1min, isumalmin, jrest, imove
!corr      USE commandsmod
!corr      USE variables, only: atm,ref
!corr      USE reflection_type_util
!corr      USE Riflessi, only: fcvet,IndHKL
!corr      implicit none
!corr      common /priori/iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
!corr      integer :: iprioro,ipriorp,ipriors,ipriopa,ipriofr,ksetfo
!corr      common /step_extra/ipriort,iprio,ipriosta,sogran,thetsav1,thetsav2
!corr     *,ncounsav1,ncounsav2,fracout,ioptim
!corr      integer :: ipriort,iprio,ipriosta,ncounsav1,ncounsav2,ioptim
!corr      real :: sogran,thetsav1,thetsav2,fracout
!corr      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!corr      integer :: icomq,maxcom,ipcom,ipdir,icomat
!corr      integer :: ier, iEnd
!corr      integer :: ip
!corrc
!corrcFIXME-corrado-prova per attivare il riciclo da 'OLD PROJECT'
!corr      if (nats == 0 .or. nrefl == 0) return
!corr!
!corr      if (icomat == 0) then
!corr          icomat = 2
!corr          icomq(1,1) = 11
!corr          icomq(2,1) = 12
!corr      endif
!corrcorrado-prova
!corr      jrest=0
!corr!corr      icomat=icomat-1
!corr!corr      call UseFragmn(ier)
!corr!corr      if(ier.lt.0)return
!corr!
!corr!     add directive fsir (iext=3) to read fc from the model (see reflin)
!corr      ip = command_position(commands,'extraction',back=.true.)
!corr      if (ip == 0) return
!corr      call add_directive(commands(ip),['fsir','fast'])
!corr      call create_expo_commands(commands,ipcom,icomq,card)
!corr      icomat = ip - 1
!corr      ipdir = sum(commands(:icomat)%ndir)
!corr      !call print_commands(commands,0)
!corrc     ifc=0
!corrc
!corr      ipriofr = ipriofr+1
!corrc     call calcfc(ifc,ier)
!corr      !call calcfc(ier)
!corr      !if(ier.lt.0)return
!corr      write(lo,550)
!corr!
!corr!     Calculate s.f. e write on the reflection list
!corr        !write(0,*)'SIZE=',size(ref), size(fcvet),nrefl,size(IndHKL(:,1))
!corr      call sfcalc(ref,atm,spacegr,celem)
!corr      fcvet(:nrefl) = ref%fc*ref%fc
!corr      call CreaListaRiflessi
!corr!!!!!prova
!corrc      ipriofr = ipriofr+1
!corrc      call prepal6
!corr      istep_extra=1
!corr      ipriort=ipriorp+ipriors+ipriopa+ipriofr
!corr!corr-evita che 'Lowest Phase Error' sia sbagliato in phase
!corr!init of these variables is in phase.f
!corr!corr      setmin = 0
!corr!corr      erm1min  = 9999
!corr!corr      isumalmin=0
!corr!corr
!corr      call gescom(POW_FILE,iEnd,ier)
!corrc
!corr550   format(/,15x,'***   Fragment information will be used as   ***',
!corr     &       /,15x,'***        prior information in Extra        ***')
!corrc
!corr      return
!corr      end
!corr#endif
!----------------------------------------------------------------------------
!!mr      subroutine polpo_procedure
!!mr      USE Molcom
!!mr      USE General
!!mr      USE Atomi, only:nats,aLab
!!mr      USE elements, only: is_element,O_at
!
!!mr      character*8 LabN
!
CORO
!corr       ioxx=0
!corr      do 101 j=1,nk
!corr        if(no(j).eq.8)then
!corr        ioxx=1
!corr        exit
!corr        endif
!corr  101 continue
!corr      if(ioxx.eq.0)then
!!mr      if (is_element(celem,O_at) > 0) then
!!mr          ier=-1
!!mr          write(Msg,9115)
!!mr 9115     format('Error: The POLPO procedure',
!!mr     &           ' can be used for oxigen completion.'
!!mr     &           ' No oxigen is in the unit cell content.')
!!mr          call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
!!mr          return
!!mr      endif
CORO
!
!!mr      do i=1,nats
!!mr         L = Lung(aLab(i))
!!mr         LabN = aLab(i)
!!mr         It(i) = LabN(1:Lung(LabN))//'@'
!!mr      enddo
!
!!mr      call c_open_polpo(It,nats)
!
!!mr      return
!!mr      end
croc
! ----------------------------------------------------------------------
!qt      subroutine setintervals(n_interval)
!qt      USE Conteggi
!qt      USE PatternRef
!qt      USE arrayutil
!qt      USE view
!qt!
!qt      common /step/ thet1(10),thet2(10),ncoun1(10),ncoun2(10)
!qt     *,nref1(10),nref2(10),ymx(10),nnt
!qt     *,thet11(10),thet22(10),ncoun11(10),ncoun22(10)
!qt     *,nref11(10),nref22(10),sscl(10),scala(10)
!qt      common/nmmn/ nmm1(10),nmm2(10),nmm11(10),nmm22(10)
!qt!
!qt      integer*4 n_interval
!qt!
!qt!     n_interval = -1 --> passa al C gli estremi degli intervalli e il loro nume
!qt!     n_interval = 0  --> passa al fortran gli estremi degli intervalli modifica
!qt!                         e restituisce un codice di errore al C
!qt!                         ier = -1 -> errore nella definizione degli intervalli
!qt!                         ier =  0 -> intervalli correttamente definiti
!qt!
!qt      if (n_interval == -1) then
!qt          n_interval = nnt - 2
!qt          do i=1,nnt-1
!qt             theta_left(i) = thet1(i)
!qt             theta_right(i) = thet2(i)
!qt          enddo
!qt      else
!qt          isav0=0
!qt          isav=nnt-1
!qt          do i=1,nnt-1
!qt!
!qt             nmm1(i) = ncoun1(i)
!qt             nmm2(i) = ncoun2(i)
!qt             nmm11(i) = ncoun11(i)
!qt             nmm22(i) = ncoun22(i)
!qt!
!qt!             write(0,*)'int=',i-1,theta_left(i),theta_right(i)
!qt             ncoun1(i) = clocate(theta_int(:,7),theta_left(i))
!qt             ncoun2(i) = clocate(theta_int(:,7),theta_right(i))
!qt             if(isav0.eq.0.and.theta_right(i).ge.thmax)then
!qt               isav=i
!qt               isav0=1
!qt             endif
!qt!
!qt          enddo
!qt!
!qt          ier = 0
!qt          nnt=isav+1
!qt          call changeint(ier)
!qt          n_interval = ier
!qt          call vedinew(2,1,npunti)
!qt      endif
!qt!
!qt      return
!qt      end
!------------------------------------------------------------------------------
!corr      subroutine set_range(iaction)
!corr      USE Conteggi
!corr      USE view
!corr      USE grexpomod
!corr      USE PatternRef
!corr      USE arrayutil
!corr      USE enable_amb
!corr      USE datasetmod
!corr      USE variables, only: dataset
!corr      USE peak_util
!corr      USE peak_mod
!corr      USE datamod
!corr!
!corr      implicit none
!corr      common /limiti/ nlini, nlfin
!corr      integer :: nlini, nlfin
!corr      common /range_default/thminp_def,thmaxp_def,nlim1_def,nlim2_def,
!corr     *nlini_def,nlfin_def,kdefault
!corr      real :: thminp_def, thmaxp_def
!corr      integer :: nlim1_def,nlim2_def,nlini_def,nlfin_def,kdefault
!corr      integer :: iaction
!corr      real, allocatable, dimension(:,:), save :: thetac
!corr      integer, save                           :: npuntisav
!corr      integer                                 :: iflagref
!corr      logical, save :: modif
!corr!
!corr      select case(iaction)
!corr        case (0)
!corr          call abilita_tasti('window_pattern')
!corr          call toolbar_set_state('continue'//char(0),0)
!corr!
!corr!         Passa info alla grafica
!corr          theta_left(1) = theta_int(1, 7)
!corr          theta_right(1) = theta_int(npunti, 7)
!corr!
!corr!         Salva conteggi per modifica
!corr          allocate(thetac(npunti,7))
!corr          thetac(:,:) = theta_int(:,:)
!corr          npuntisav = npunti
!corr          modif = .false.
!corr
!corr        case (1,2)                    ! 1=Apply, 2=OK
!corr          nlini = clocate(theta_int(:,7),theta_left(1))
!corr          nlfin = clocate(theta_int(:,7),theta_right(1))
!corr          if (nlini /= 1 .or. nlfin /= npunti) then
!corr              thminp = theta_int(nlini, 7)
!corr              thmaxp = theta_int(nlfin, 7)
!corr              call dataset(1)%resize(thminp,thmaxp)
!corr!
!corr!             resize peaks
!corr              if (numpeaks(pkind) > 0) then
!corr              call peak_select(pkind,thminp,thmaxp,DELETE_PEAK
!corr     *                         ,outside=.true.)
!corr              call peak_delete_selected(pkind)
!corr              endif
!corr!
!corr              call modifica_range()
!corr              modif = .true.
!corr          endif
!corr!
!corr!         Disegna anche per forzare la scomparsa delle barre
!corr          call vedinew(pinioss=1,pfinoss=npunti)
!corr!
!corr          if (iAction == 2) then
!corr              deallocate(thetac)
!corr              call abilita_tasti('pattern')
!corr              call wmenu_set_state('Range'//char(0),1)
!corr              call toolbar_set_state('continue'//char(0),1)
!corr              if (modif) then  ! update modify_range for input file 
!corr                  modify_range = .true.
!corr                  minrange = thmin
!corr                  maxrange = thmax
!corr              endif
!corr          endif
!corr
!corr        case (3)                    ! Cancel
!corr!
!corr!         Ripristina i conteggi in caso di modifica
!corr          if (npunti /= npuntisav) then
!corr              call AllocaConteggi(2)
!corr              npunti = npuntisav
!corr              call AllocaConteggi(1)
!corr              theta_int(:,:) = thetac(:,:)
!corr              thmin = theta_int(1,7)
!corr              thmax = theta_int(npunti,7)
!corr              call gener(dataset(1)%wave,iflagref,.false.)
!corr          endif
!corr!
!corr!         Disegna anche per forzare la scomparsa delle barre
!corr          call vedinew(pinioss=1,pfinoss=npunti)
!corr!
!corr          deallocate(thetac)
!corr          call abilita_tasti('pattern')
!corr          call wmenu_set_state('Range'//char(0),1)
!corr          call toolbar_set_state('continue'//char(0),1)
!corr          modif = .false.
!corr
!corr      end select
!corr!
!corr      return
!corr      end
!------------------------------------------------------------------------------
!corr      subroutine prendi_speciepes(nspecpes,natsfort, ilim)
!corr!
!corr      USE Atomi, only : nats
!corr      USE PhaseModule
!corr      integer*4 nspecpes
!corr      integer*4 natsfort
!corr      integer*4 ilim
!corr!
!corr      natsfort=nats
!corr      call speciepesanti(nspecpes, ilim)
!corr!
!corr      return
!corr      end
! ---------------------------------------------------------------------
!qt      subroutine zoom_right(iCod)
!qt      USE VIEW
!qt!
!qt      integer*4 iCod ![REFERENCE]
!qt!
!qt      call zoom_next(icod)
!qt!
!qt      return
!qt      end
! ---------------------------------------------------------------------
!qt      subroutine calcola_d(d_value, count)
!qt      USE Riflessi
!qt      USE General
!qt      common /ureq1/ ncycl,nroset,nundset,nsec,jback,uvwt(8),
!qt     *               itry,pfwhm,kequirip
!qt!
!qt      real      d_value      ![REFERENCE]
!qt      real      count        ![REFERENCE]
!qt!
!qt      integer, dimension(1) :: loc
!qt      character(len=40)     :: line
!qt      integer, save         :: flagref = 0
!qt!
!qt      if (count < 0 .and. nrefl > 0) then
!qt          loc = minloc(abs(TThet(:nrefl)-d_value))
!qt          write(line(1:37),'(i4,a,3i3,2x,a13,f8.3)')loc,')',
!qt     *    IndHKL(loc,1:3),'2-Theta ref.:',TThet(loc)
!qt          call PrintMess(line)
!qt          flagref = 1
!qt      else
!qt          if (flagref == 1) then  !ripulire la stringa se si torna nell'area con
!qt              call ClearMessage()
!qt              flagref = 0
!qt          endif
!qt      endif
!qt      d_value = alambda/(2.0*sin(0.5*d_value*dtor))
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!qt      subroutine disegna_rulers(pleft,pright)
!qt      USE GREXPOMOD, only:scalex,dispx,iselview
!qt!
!qt      real, intent(in) :: pright,pleft
!qt!
!qt      ileft = nint(pleft*scalex(iselview) + dispx(iselview))
!qt      iright = nint(pright*scalex(iselview) + dispx(iselview))
!qt      call draw_rulers(ileft,iright)
!qt      return
!qt      end
!-----------------------------------------------------------------------
      subroutine disegna_display_legend()
      USE PatternRef
!
      call draw_display()
      return
      end
! ---------------------------------------------------------------------
      subroutine change_fontheight(kfnt)
      USE view
      USE Molcom
      USE conteggi, only:npunti
      implicit none
      integer :: kfnt
!
      FntPixHeight = kfnt
      if (npunti > 0) call vedinew()
!
      return
      end
! ---------------------------------------------------------------------
      subroutine stop_fortran_visible(visible)
      USE General, only: ifAutomatic
      USE Molcom, only: kscreen
      implicit none
      interface
         subroutine c_stop_fortran_visible(visible) 
     *   bind(C,name="c_stop_fortran_visible")
         use iso_c_binding
         integer(c_int), intent(in), value :: visible
         end subroutine c_stop_fortran_visible
      end interface
      integer, intent(in) :: visible
!
      if (kscreen == 1 .and. ifAutomatic == 0) then
          call c_stop_fortran_visible(visible)
      endif
!      
      end subroutine stop_fortran_visible
! ---------------------------------------------------------------------
      subroutine stop_fortran()
      USE General, only: ifAutomatic
      USE Molcom, only: kscreen
      USE interop_cpp_for, only: dosingleiteration
      implicit none
      interface
         subroutine c_stop_fortran() bind(C,name="c_stop_fortran")
         end subroutine c_stop_fortran
      end interface
!
      if (kscreen == 1 .and. ifAutomatic == 0) then
          call c_stop_fortran()
          call DoSingleIteration()
      endif
!
      return
      end
! -----------------------------------------------------------------
!!mr      subroutine startlabelling()
!!mr      USE General
!!mr      USE PatternRef
!
!     nspec_lab      = numero di specie selezionate (1 o 2)
!
!     ncoord_lab     = 1 --> coordinazione tetraedrica
!     ncoord_lab     = 2 --> coordinazione ottaedrica
!     ncoord_lab(1)  = coordinazione della prima specie
!     ncoord_lab(2)  = coordinazione della seconda specie
!
!     ispecie_lab(1) = num. d'ordine della prima specie
!     ispecie_lab(2) = num. d'ordine della seconda specie
!
!     npeaks_lab(1)  = num. di picchi da rilabellare per la prima specie
!     npeaks_lab(2)  = num. di picchi da rilabellare per la seconda specie
!
!     valori_lab(1) = distanza pesante-pesante
!     valori_lab(2) = tolleranza sulla distanza pesante-pesante
!     valori_lab(3) = distanza pesante-leggero
!     valori_lab(4) = tolleranza sulla distanza pesante-leggero
!
!
!  10 format(
!    *  'Variabili in uscita dalla interfaccia LABELLING:',/
!    *  '    nspec_lab       =',i4)

!     write(0,20) (i,ncoord_lab(i),i=1,nspec_lab)
!  20 format(
!    *  '    ncoord_lab(',i2,')',i4)

!     write(0,30) (i,ispecie_lab(i),i=1,nspec_lab)
!  30 format(
!    *  '    ispecie_lab(',i2,')',i4)

!     write(0,40) (i,npeaks_lab(i),i=1,nspec_lab)
!  40 format(
!    *  '    npeaks_lab(',i2,')',i4)

!     write(0,50) (i,valori_lab(i),i=1,4)
!  50 format(
!    *  '    valori_lab(',i2,')',f6.3)
!
!!mr      jrests = 0
!!mr      call changelabel(ier,iier)
!
!!mr      if (iier < 0) then
!!mr          Msg = ' Programming error in Labelling'//char(10)//
!!mr     *          ' Check output'
!!mr          call MsgWinErr('Error', Msg, ERR_WINDOW, nExitCode)
!!mr      endif
!
!!mr      return
!!mr      end
!-----------------------------------------------------------------------
!corr      subroutine startpolpo()
!corr      USE General
!corr      USE Atomi
!corr      USE variables, only: atm,lconn
!corr      USE sinterface
!corr      USE Conteggi, only: npunti
!corr      common /graphic_restart/kgraph_restart,ncyc_restart,nset_restart
!corr      common /conteggisav/npuntisav,nrefsav
!corr!
!corr      kgraph_restart=1
!corr      call polyedra(ier)
!corr
!corr!Ripristina nrefl e npunti
!corr      npunti=npuntisav
!corr      nrefl=nrefsav
!corr
!corr      kgraph_restart=0
!corr      call scrper(' ',0,-1)
!corr      if (ier /= 0) then
!corr          Msg = ' Programming error in polyedra'//char(10)//
!corr     *          ' Check output'
!corr          call MsgWinErr('Error', Msg, ERR_WINDOW, nExitCode)
!corr          call atom_to_xyzs(atm,lconn)      ! ripristina il vecchio modello
!corr      else
!corr          call update_atm()   ! aggiorna atm, lconn
!corr      endif
!corr!
!corr      return
!corr      end
! ---------------------------------------------------------------------

      subroutine export_file_exp()
!
!     Crea un nuovo file .exp del tipo nomefile1.exp
!
      USE General
      USE programinput
      USE fileutil
      implicit none
      character(len=780)  :: newf
      integer             :: nExitC
!
!     Genera il nome del file
      newf = trim(file_rem_ext(fname(INP_FILE)))//'1'//'.exp'
!
!     Mostra messaggio informativo
      Msg = 'Input file '//trim(newf)//' with new '//
     *      'crystal data will be created'
      call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
!
!     Leggi la cella dalla lista
      call xfl01()
!
!     Scrivi il nuovo file
      call write_input_file(input_file_create(newf))
!
      end subroutine export_file_exp

!-----------------------------------------------------------------------
!corr
!corr      subroutine open_summary3(length,filename) bind(C)
!corr      use iso_c_binding, only: c_char, c_int
!corr      implicit none
!corr      character(length,kind=c_char), intent(in) :: filename
!corr      integer(c_int), intent(in), value  :: length
!corr      character(len=:), allocatable :: filenam
!corr      integer :: i
!corr!
!corr      !allocate(character(length) :: filenam)
!corr      !forall(i = 1:length) filenam(i:i) = filename(i)
!corr      write(0,*)'FILE2: ',filename
!corr!
!corr      end subroutine open_summary3
!corr
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!qt      subroutine BrowserV2(kBro)
!qt      USE General
!qt      USE view
!qt      USE reflection_type_util, only: reflection_type
!qt!
!qt      implicit none
!qt      integer                                          :: kBro
!qt      character(len=80)                                :: filename
!qt      type(reflection_type), dimension(:), allocatable :: reflb
!qt      integer, dimension(9)                            :: vet
!qt      type(reflection_type), dimension(:), allocatable :: table
!qt      integer                                          :: istat,iform
!qt      integer                                          :: jop,jopen
!qt      integer                                          :: ierr,ier
!qt!
!qt      select case (kBro)
!qt         case (1)       ! Info -> Summury
!qt              filename = 'tmp.tmp'
!qt              istat = 0
!qt              iform = 1
!qt              ier = 0
!qt              jop=jopen(iscra,filename,istat,iform,ierr)
!qt              Inte = 'General informations'
!qt              call GenInfoV2
!qt              close(iscra)
!qt              if (ier == 0) call CDialogo (Inte, filename, kBro)
!qt         case (5)       ! Info -> Output file
!qt              filename = 'tmp.tmp'
!qt              istat = 0
!qt              iform = 1
!qt              ier = 0
!qt              jop=jopen(iscra,filename,istat,iform,ierr)
!qt              Inte = 'Viewing printer output file : '//
!qt     *               trim(fname(OUT_FILE))
!qt              call StampaOutputV2(ier)
!qt              close(iscra)
!qt              if (ier == 0) call CDialogo (Inte, filename, kBro)
!qt         case (7)       ! Info -> HKL list
!qt              call set_reflection_table(table,vet,2,ier,idph)
!qt              if (ier == 0) then
!qt                  call listhkl(table, vet, size(table), idph)
!qt              endif
!qt      end select
!qt! --
!qt      return
!qt      end
! -----------------------------------------------------------------
      subroutine chiudi_bin(flag)
      USE General
      USE Molcom
      USE conteggi, only:npunti
!
      Integer*4 flag ![REFERENCE]
!
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
!
      if(flag.eq.1) then
         close(jdir, status = 'delete')
      else
         call xdump()
         close(jdir)
      endif
      icfle=-1
      ifProject = 0
      jscreen = 1
      call AllocaConteggi(2); npunti=0
      call AllocaCalcfig(2)
      call AllocaCalcProfile(2)
      call AllocaProfileApp(2)
      call AllocaSmoothing(2)
      call AllocaDeriv(2)
      call AllocaCalcProfileApp(2)
      call AllocaCorrelazione(2)
      call AllocaBackintsav(2)
      call AllocaExtraIndix(2)
C     call AllocaRiflessi(2)
C     call AllocaPhaseStuff(2)
C     call AllocaMappa(2)
!
      call InitExpo2002(1)
      return
      end
! ----------------------------------------------------------------------
!corr      subroutine manage_symm(ier,SPGroup,CellConditions)
!corr      USE General
!corr      USE Symmetry
!corr!
!corr      character*(*) SPGroup
!corr      integer*4 ier         ![REFERENCE]
!corr      integer*4 CellConditions(14)
!corr!
!corr      dimension kshif(3)
!corr!
!corr
!corr      call Shift(SPGroup,nchar)
!corr      ier = 0
!corr      call lcase(SPGroup)
!corr      lenp = 16
!corr      call onebl(SPGroup,lenp,ier)
!corr      if (ier.lt.0) then
!corr          write(Msg,10) SPGroup
!corr          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
!corr          return
!corr      endif
!corr   10 format('Error in Space Group Symbol:',a)
!corr      read(SPGroup,'(16a1)') nSpaceG
!corr      call ti1983(nSpaceG)
!corr      ishif = 0
!corr      kshif(1) = 0
!corr      kshif(2) = 0
!corr      kshif(3) = 0
!corr      call insym(ishif,kshif,ier)
!corr      if (ier < 0) then
!corr          return
!corr      endif
!corr!
!corr      CellConditions = -100
!corr      CellConditions(14) = jsys
!corr      select case (jsys)
!corr             case (2)
!corr                  if (kmat(2,1,1).eq.kmat(2,2,2)) then
!corr                      CellConditions( 4) = 90
!corr                      CellConditions( 5) = 90
!corr                      CellConditions(10) =  0
!corr                      CellConditions(11) =  0
!corr                  else if (kmat(2,1,1).eq.kmat(2,3,3)) then
!corr                      CellConditions( 4) = 90
!corr                      CellConditions( 6) = 90
!corr                      CellConditions(10) =  0
!corr                      CellConditions(12) =  0
!corr                  else if (kmat(2,2,2).eq.kmat(2,3,3)) then
!corr                      CellConditions( 5) = 90
!corr                      CellConditions( 6) = 90
!corr                      CellConditions(11) =  0
!corr                      CellConditions(12) =  0
!corr                  endif
!corr             case (3)
!corr                  CellConditions( 4) =  90
!corr                  CellConditions( 5) =  90
!corr                  CellConditions( 6) =  90
!corr                  CellConditions(10) =   0
!corr                  CellConditions(11) =   0
!corr                  CellConditions(12) =   0
!corr
!corr             case (4)
!corr                  CellConditions( 2) =  -1
!corr                  CellConditions( 4) =  90
!corr                  CellConditions( 5) =  90
!corr                  CellConditions( 6) =  90
!corr                  CellConditions( 8) =  -7
!corr                  CellConditions(10) =   0
!corr                  CellConditions(11) =   0
!corr                  CellConditions(12) =   0
!corr
!corr             case (5)
!corr                  CellConditions( 2) =  -1
!corr                  CellConditions( 4) =  90
!corr                  CellConditions( 5) =  90
!corr                  CellConditions( 6) = 120
!corr                  CellConditions( 8) =  -7
!corr                  CellConditions(10) =   0
!corr                  CellConditions(11) =   0
!corr                  CellConditions(12) =   0
!corr
!corr             case (6)
!corr                  CellConditions( 2) =  -1
!corr                  CellConditions( 3) =  -1
!corr                  CellConditions( 4) =  90
!corr                  CellConditions( 5) =  90
!corr                  CellConditions( 6) =  90
!corr                  CellConditions( 8) =  -7
!corr                  CellConditions( 9) =  -7
!corr                  CellConditions(10) =   0
!corr                  CellConditions(11) =   0
!corr                  CellConditions(12) =   0
!corr      end select
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!corr       integer*4 function f_checkisnumeric(stringa)
!corr !
!corr       character *(*) stringa
!corr !
!corr       f_checkisnumeric = Lung(stringa)
!corr       read(stringa, *, err=99) fnum
!corr       return
!corr   99  f_checkisnumeric = -1
!corr !
!corr       return
!corr       end
!-----------------------------------------------------------------------
!corr      subroutine prendi_space_groups(rowspace,numspace,csdfreq,strspace)
!corr      USE Molcom
!corr      USE PatternRef, only:pos_absref
!corr!
!corr      Integer*4 rowspace    ![REFERENCE]
!corr      Integer*4 numspace    ![REFERENCE]
!corr      integer, dimension(*) :: csdfreq
!corr      character(len=20), dimension(20) :: strspace
!corr!
!corr      pos_absref = 0    ! azzera la posizione del riflesso estinto da visualizzare
!corr      call get_space_from_file(rowspace,numspace,csdfreq,strspace)
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!corr      subroutine get_atoms_from_F(CnAt)  
!corr      USE Atomi
!corr      USE Molcom
!corr      implicit none
!corr      integer :: i, L, Lung
!corr      integer*4 CnAt
!corr!
!corr      It = ' '
!corr      do i=1,nats
!corr         L = Lung(aLab(i))
!corr         It(i)(1:L+1) = aLab(i)(1:L) // char(0)
!corr      enddo
!corr      It(nats+1)(1:1) = char(0)
!corr      CnAt = nats
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
      subroutine get_nz_from_F(nzeta)
      USE Atomi
      implicit none 
      integer nzeta(*), i
!
      do i=1,nats
         nzeta(i) = iabs(nz(i)) / nzConst
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine toflush()
! ---
!     INTERFACE TO SUBROUTINE toflushc [C, ALIAS:'_toflushc'] ()
!     END
! ---
      !call toflushc()
!
      return
      end
!-----------------------------------------------------------------------
!!      subroutine PassaVettoreStr(vettstr, dimensione)
!
!!      implicit none

!!      integer dimensione
!!      character*(*) vettstr(dimensione)
!
!!      call put_vett_str (vettstr, dimensione)
!
!!      return
!!      end
!-----------------------------------------------------------------------
      subroutine cCopyFile(fsrc, fdst)
!
      implicit none
      integer Lung
      character*(*) fsrc, fdst
!
      call c_copyfile(fsrc(1:Lung(fsrc))//char(0),
     *                fdst(1:Lung(fdst))//char(0))
!
      return
      end
!-----------------------------------------------------------------------
!qt
!qt      subroutine puntibg(iFlag)
!qt      USE PatternRef
!qt      USE view
!qt      USE plotstyle
!qt      implicit none
!qt      integer       :: iFlag  ! = 0 NON disegno i punti di background
!qt                                    ! = 1 disegno i punti di background
!qt      integer, save :: iBack1user
!qt!
!qt      if (iFlag == 1) then
!qt!
!qt!         Entro nella grafica di modifica del background
!qt          iBack1user = style(STYLE_BACKP)%vis   ! salvo la scelta dell'utente
!qt          if (style(STYLE_BACKP)%vis == 0) then
!qt              style(STYLE_BACKP)%vis = 1
!qt              call vedinew()
!qt          endif
!qt      else
!qt!
!qt!         Esco dalla grafica di modifica del background
!qt          if (iBack1user == 0) then ! Solo se la scelta dell'utente è di non mostrare i punti ...
!qt              style(STYLE_BACKP)%vis = 0
!qt              call vedinew()
!qt          endif
!qt      endif
!qt!
!qt      return
!qt      end 
! ----------------------------------------------------------------------
      subroutine lanciajavs()
      USE variables, only: cryst
      USE ilmviewmod
      USE General, only:StructureName
      implicit none
!
      call ilmview_open(StructureName)
      call ilmview_draw(cryst(1)%at,cryst(1)%bond,cryst(1)%elem,
     *cryst(1)%cell,cryst(1)%spg)
!
      end subroutine lanciajavs
!-----------------------------------------------------------------------
!      function CellVolumeForC(cell) result(volume) bind(C,name="CellVolumeForC")
!corr      real function CellVolumeForC(cella)
!corr      USE unit_cell
!corr      real cella(6)
!corr!
!corr      CellVolumeForC = cell_volume(cella)
!corr!
!corr      end function CellVolumeForC
!-----------------------------------------------------------------------
!corr       real function ContentVolumeforC(nEl, El, Am)
!corr       USE elements
!corr !
!corr       character (len = 5), dimension(*) :: El
!corr       integer nEl, Am(*)
!corr       character (len = 5), dimension(:), allocatable :: specv
!corr       real , dimension(:), allocatable            :: nspecv
!corr !
!corr       ALLOCATE (nspecv(1:nEl), specv(1:nEl))
!corr       do i=1, nEl
!corr          k = Lung(El(i))
!corr          El(i)(k+1:) = ' '
!corr          nspecv(i) = Am(i)
!corr          specv(i) = El(i)(1:k)
!corr       enddo
!corr       ContentVolumeforC=content_volume(pxen_from_specie(specv), nspecv)
!corr       DEALLOCATE (nspecv, specv)
!corr !
!corr       end function ContentVolumeforC
!-----------------------------------------------------------------------
!corr       real function VolumeperAtomforC(nEl, El, Am, Vol, dens)
!corr       USE atom_type_util
!corr                            USE elements
!corr !
!corr       character (len = 5), dimension(*)   ::El
!corr       integer nEl, Am(*)
!corr       character (len = 5), dimension(:), allocatable   :: specv
!corr       integer , dimension(:), allocatable              :: nspecv
!corr       real Vol, dens
!corr !
!corr       ALLOCATE (nspecv(1:nEl), specv(1:nEl))
!corr       do i=1, nEl
!corr          k = Lung(El(i))
!corr          El(i)(k+1:) = ' '
!corr          nspecv(i) = Am(i)
!corr          specv(i) = El(i)(1:k)
!corr       enddo
!corr       VolumeperAtomforC = volume_per_atom(specv, nspecv, Vol)
!corr !!!!!!test
!corr       dens = density_value(molecular_weight(pxen_from_specie(specv),
!corr      *real(nspecv)),vol,1)
!corr !!!!!!test
!corr       DEALLOCATE (nspecv, specv)
!corr !
!corr       end function VolumeperAtomforC
!-----------------------------------------------------------------------
      integer function GetNkNo(no_forC)
      USE progtype, only:NMAXSPECIE
      USE elements
      USE General, only: celem
      implicit none
      integer         :: no_forC(NMAXSPECIE)  !corr, nkk, i
      integer :: nelem
!
      nelem = numelem(celem)
      no_forC(:nelem) = celem%ptab
      no_forC(nelem+1:NMAXSPECIE) = 0
      GetNkNo = nelem
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine show_selected_reflection(numr)
!corr      USE view
!corr      USE variables, only: dataset
!corr      USE datasetmod
!corr!corr      USE importexport
!corr!
!corr      implicit none
!corr      integer               :: numr
!corr      integer, dimension(1) :: vet,vph
!corr!
!corr      if (ndataset(dataset) == 0) return
!corr      if (dataset(1)%npoints() > 0 .and. 
!corr     *dataset(1)%datatype == POW_DATA) then
!corr          call reset_selection()
!corr          !vet(1) = numr
!corr          vet(1) = count(idph(:numr) == idph(numr)) ! id in the reflection list of phase idph(numr)
!corr          vph(1) = idph(numr)
!corr          call add_to_selection(vet,vph)
!corr          call vedinew()
!corr      endif
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
!corr      subroutine save_hklinfo(filnam, ncol, vet, ftype)
!corr      USE reflection_type_util
!corr      USE fileutil
!corr      USE view
!corr      USE importexport
!corr      implicit none
!corr      integer, intent(in)                              :: ncol, ftype
!corr      integer, dimension(ncol), intent(in)             :: vet
!corr      character(len=*), intent(in)                     :: filnam
!corr      integer                                          :: ier
!corr!!mr      integer, dimension(8)                            :: vetr
!corr      integer, dimension(9)                            :: vetr
!corr      type(reflection_type), dimension(:), allocatable :: table
!corr      type(file_handle)                                :: fref
!corr!
!corr! ftype = 1   --> Fo Fc
!corr!       = 2   --> Fo^2 Fc^2
!corr!
!corr      call fref%fopen(filnam,'w')
!corr      if (fref%good()) then
!corr          call set_reflection_table(table,vetr,ftype,ier,idph)   ! ricrea la tabella
!corr          call write_reflection_table(table,vet,fref%handle(),ftype)       ! stampa la tabella
!corr          call fref%fclose()
!corr      endif
!corr!
!corr      return
!corr      end
!corr!-----------------------------------------------------------------------
!corr      subroutine close_hklinfo()
!corr      USE view 
!corr      USE variables, only: dataset
!corr      USE datasetmod
!corr      implicit none
!corr!
!corr      if (ndataset(dataset) == 0) return
!corr      if (dataset(1)%npoints() > 0 .and. 
!corr     *dataset(1)%datatype == POW_DATA) then
!corr          call reset_selection()
!corr          call vedinew()
!corr      endif
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
      subroutine lista_func(iCode)
!
      implicit none
      integer iCode
!
      write(*, *) 'lista_func: code = ', iCode
!
      return
      end
!-----------------------------------------------------------------------
      integer function get_content_from_formula(line, v1, v2)
!
      USE elements
      implicit none
      character(len=*)                              :: line
      type(element_type), dimension(:), allocatable :: elem
      integer, dimension(*)                         :: v1, v2
      integer                                       :: ier, i, n
!
      call read_chemformula(line,ier,elem=elem)
      if (ier > 0) then
          get_content_from_formula = -1
      else
          n = size(elem)
          get_content_from_formula = n
          do i=1, n
             v1(i) = elem(i)%nw
             v2(i) = elem(i)%z
          end do
      endif
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine provafindprog()
!qt
!qt      implicit none
!qt      character stringa*256
!qt      integer i, FindProg, Lung
!qt!
!qt      i = FindProg("expo", stringa);
!qt      if(i > 0) then
!qt         write(*, *) 'expo is in ', stringa(1:Lung(stringa))
!qt      else
!qt         write(*, *) 'expo not found'
!qt      endif
!qt!
!qt      return
!qt      end
